/* tslint:disable */
/* eslint-disable */
/**
 * Coscine Web API
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import type { Configuration } from '../../configuration';
import type { AxiosPromise, AxiosInstance, RawAxiosRequestConfig } from 'axios';
import globalAxios from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, type RequestArgs, BaseAPI, RequiredError, operationServerMap } from '../../base';
// @ts-ignore
import type { ResourceTypeInformationDtoIEnumerableResponse } from '../../@coscine/model';
// @ts-ignore
import type { ResourceTypeInformationDtoResponse } from '../../@coscine/model';
/**
 * ResourceTypeApi - axios parameter creator
 * @export
 */
export const ResourceTypeApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2ResourceTypesOptions: async (options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v2/resource-types`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'OPTIONS', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Retrieves the entire global resource types information.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getAllResourceTypesInformation: async (options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v2/resource-types/types`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Retrieves the resource type information for a specific resource type.
         * @param {string} resourceTypeId The ID of the resource type to retrieve.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getResourceTypeInformation: async (resourceTypeId: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'resourceTypeId' is not null or undefined
            assertParamExists('getResourceTypeInformation', 'resourceTypeId', resourceTypeId)
            const localVarPath = `/api/v2/resource-types/types/{resourceTypeId}`
                .replace(`{${"resourceTypeId"}}`, encodeURIComponent(String(resourceTypeId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * ResourceTypeApi - functional programming interface
 * @export
 */
export const ResourceTypeApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = ResourceTypeApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV2ResourceTypesOptions(options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV2ResourceTypesOptions(options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ResourceTypeApi.apiV2ResourceTypesOptions']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Retrieves the entire global resource types information.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getAllResourceTypesInformation(options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ResourceTypeInformationDtoIEnumerableResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getAllResourceTypesInformation(options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ResourceTypeApi.getAllResourceTypesInformation']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Retrieves the resource type information for a specific resource type.
         * @param {string} resourceTypeId The ID of the resource type to retrieve.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getResourceTypeInformation(resourceTypeId: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ResourceTypeInformationDtoResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getResourceTypeInformation(resourceTypeId, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ResourceTypeApi.getResourceTypeInformation']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
    }
};

/**
 * ResourceTypeApi - factory interface
 * @export
 */
export const ResourceTypeApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = ResourceTypeApiFp(configuration)
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2ResourceTypesOptions(options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.apiV2ResourceTypesOptions(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Retrieves the entire global resource types information.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getAllResourceTypesInformation(options?: RawAxiosRequestConfig): AxiosPromise<ResourceTypeInformationDtoIEnumerableResponse> {
            return localVarFp.getAllResourceTypesInformation(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Retrieves the resource type information for a specific resource type.
         * @param {ResourceTypeApiGetResourceTypeInformationRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getResourceTypeInformation(requestParameters: ResourceTypeApiGetResourceTypeInformationRequest, options?: RawAxiosRequestConfig): AxiosPromise<ResourceTypeInformationDtoResponse> {
            return localVarFp.getResourceTypeInformation(requestParameters.resourceTypeId, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for getResourceTypeInformation operation in ResourceTypeApi.
 * @export
 * @interface ResourceTypeApiGetResourceTypeInformationRequest
 */
export interface ResourceTypeApiGetResourceTypeInformationRequest {
    /**
     * The ID of the resource type to retrieve.
     * @type {string}
     * @memberof ResourceTypeApiGetResourceTypeInformation
     */
    readonly resourceTypeId: string
}

/**
 * ResourceTypeApi - object-oriented interface
 * @export
 * @class ResourceTypeApi
 * @extends {BaseAPI}
 */
export class ResourceTypeApi extends BaseAPI {
    /**
     * 
     * @summary Responds with the HTTP methods allowed for the endpoint.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ResourceTypeApi
     */
    public apiV2ResourceTypesOptions(options?: RawAxiosRequestConfig) {
        return ResourceTypeApiFp(this.configuration).apiV2ResourceTypesOptions(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Retrieves the entire global resource types information.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ResourceTypeApi
     */
    public getAllResourceTypesInformation(options?: RawAxiosRequestConfig) {
        return ResourceTypeApiFp(this.configuration).getAllResourceTypesInformation(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Retrieves the resource type information for a specific resource type.
     * @param {ResourceTypeApiGetResourceTypeInformationRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ResourceTypeApi
     */
    public getResourceTypeInformation(requestParameters: ResourceTypeApiGetResourceTypeInformationRequest, options?: RawAxiosRequestConfig) {
        return ResourceTypeApiFp(this.configuration).getResourceTypeInformation(requestParameters.resourceTypeId, options).then((request) => request(this.axios, this.basePath));
    }
}

